using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RtfPipe
{
  internal enum ShapeType
  {
    AccentBorderCallout1 = 50,
    AccentBorderCallout2 = 51,
    AccentBorderCallout3 = 52,
    AccentBorderCallout90 = 181,
    AccentCallout1 = 44,
    AccentCallout2 = 45,
    AccentCallout3 = 46,
    AccentCallout90 = 179,
    ActionButtonBackPrevious = 194,
    ActionButtonBeginning = 196,
    ActionButtonBlank = 189,
    ActionButtonDocument = 198,
    ActionButtonEnd = 195,
    ActionButtonForwardNext = 193,
    ActionButtonHelp = 191,
    ActionButtonHome = 190,
    ActionButtonInformation = 192,
    ActionButtonMovie = 200,
    ActionButtonReturn = 197,
    ActionButtonSound = 199,
    Arc = 19,
    Arrow = 13,
    Balloon = 17,
    BentArrow = 91,
    BentConnector2 = 33,
    BentConnector3 = 34,
    BentConnector4 = 35,
    BentConnector5 = 36,
    BentUpArrow = 90,
    Bevel = 84,
    BlockArc = 95,
    BorderCallout1 = 47,
    BorderCallout2 = 48,
    BorderCallout3 = 49,
    BorderCallout90 = 180,
    BracePair = 186,
    BracketPair = 185,
    Callout1 = 41,
    Callout2 = 42,
    Callout3 = 43,
    Callout90 = 178,
    Can = 22,
    Chevron = 55,
    CircularArrow = 99,
    CloudCallout = 106,
    Cube = 16,
    CurvedConnector2 = 37,
    CurvedConnector3 = 38,
    CurvedConnector4 = 39,
    CurvedConnector5 = 40,
    CurvedDownArrow = 105,
    CurvedLeftArrow = 103,
    CurvedRightArrow = 102,
    CurvedUpArrow = 104,
    Diamond = 4,
    Donut = 23,
    DoubleWave = 188,
    DownArrow = 67,
    DownArrowCallout = 80,
    Ellipse = 3,
    EllipseRibbon2 = 108,
    EllipseRibbon = 107,
    FlowChartAlternateProcess = 176,
    FlowChartCollate = 125,
    FlowChartConnector = 120,
    FlowChartDecision = 110,
    FlowChartDelay = 135,
    FlowChartDisplay = 134,
    FlowChartDocument = 114,
    FlowChartExtract = 127,
    FlowChartInputOutput = 111,
    FlowChartInternalStorage = 113,
    FlowChartMagneticDisk = 132,
    FlowChartMagneticDrum = 133,
    FlowChartMagneticTape = 131,
    FlowChartManualInput = 118,
    FlowChartManualOperation = 119,
    FlowChartMerge = 128,
    FlowChartMultidocument = 115,
    FlowChartOffPageConnector = 177,
    FlowChartOfflineStorage = 129,
    FlowChartOnlineStorage = 130,
    FlowChartOr = 124,
    FlowChartPredefinedProcess = 112,
    FlowChartPreparation = 117,
    FlowChartProcess = 109,
    FlowChartPunchedCard = 121,
    FlowChartPunchedTape = 122,
    FlowChartSort = 126,
    FlowChartSummingJunction = 123,
    FlowChartTerminator = 116,
    FoldedCorner = 65,
    FreeformOrNonAutoshape = 0,
    Heart = 74,
    Hexagon = 9,
    HomePlate = 15,
    HorizontalScroll = 98,
    HostControl = 201,
    Irregularseal1 = 71,
    Irregularseal2 = 72,
    IsoscelesTriangle = 5,
    LeftArrow = 66,
    LeftArrowCallout = 77,
    LeftBrace = 87,
    LeftBracket = 85,
    LeftRightArrow = 69,
    LeftRightArrowCallout = 81,
    LeftRightUpArrow = 182,
    LeftUpArrow = 89,
    LightningBolt = 73,
    Line = 20,
    Moon = 184,
    NoSmoking = 57,
    NotchedCircularArrow = 100,
    NotchedRightArrow = 94,
    Octagon = 10,
    Parallelogram = 7,
    Pentagon = 56,
    PictureFrame = 75,
    Plaque = 21,
    PlusSign = 11,
    QuadArrow = 76,
    QuadArrowCallout = 83,
    Rectangle = 1,
    Ribbon = 53,
    Ribbon2 = 54,
    RightArrowCallout = 78,
    RightBrace = 88,
    RightBracket = 86,
    RightTriangle = 6,
    RoundRectangle = 2,
    Seal = 18,
    Seal16 = 59,
    Seal24 = 92,
    Seal32 = 60,
    Seal4 = 187,
    Seal8 = 58,
    SmileyFace = 96,
    Star = 12,
    StraightConnector1 = 32,
    StripedRightArrow = 93,
    Sun = 183,
    TextArchDownCurve = 145,
    TextArchDownPour = 149,
    TextArchUpCurve = 144,
    TextArchUpPour = 148,
    TextBox = 202,
    TextButtonCurve = 147,
    TextButtonPour = 151,
    TextCanDown = 175,
    TextCanUp = 174,
    TextCascadeDown = 155,
    TextCascadeUp = 154,
    TextChevron = 140,
    TextChevronInverted = 141,
    TextCircleCurve = 146,
    TextCirclePour = 150,
    TextCurve = 27,
    TextCurveDown = 153,
    TextCurveUp = 152,
    TextDeflate = 161,
    TextDeflateBottom = 163,
    TextDeflateInflate = 166,
    TextDeflateInflateDeflate = 167,
    TextDeflateTop = 165,
    TextFadeDown = 171,
    TextFadeLeft = 169,
    TextFadeRight = 168,
    TextFadeUp = 170,
    TextHexagon = 26,
    TextInflate = 160,
    TextInflateBottom = 162,
    TextInflateTop = 164,
    TextOctagon = 25,
    TextOnCurve = 30,
    TextOnRing = 31,
    TextPlainText = 136,
    TextRing = 29,
    TextRingInside = 142,
    TextRingOutside = 143,
    TextSimple = 24,
    TextSlantDown = 173,
    TextSlantUp = 172,
    TextStop = 137,
    TextTriangle = 138,
    TextTriangleInverted = 139,
    TextWave = 28,
    TextWave1 = 156,
    TextWave2 = 157,
    TextWave3 = 158,
    TextWave4 = 159,
    ThickArrow = 14,
    Trapezoid = 8,
    UTurnArrow = 101,
    UpArrow = 68,
    UpArrowCallout = 79,
    UpDownArrow = 70,
    UpDownArrowCallout = 82,
    VerticalScroll = 97,
    Wave = 64,
    WedgeEllipseCallout = 63,
    WedgeRectangleCallout = 61,
    WedgeRrectCallout = 62,
  }
}
